/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System.Collections.Generic;namespace PluginIdea.SlideControl{public class Camera_Marker : MVRScript{private List<string> resolutionStrs = new List<string>{"Low", "Medium", "Large"};private List<string> aspectStrs = new List<string>{"Custom","16:9", "2:1", "4:3", "1:1", "3:4", "1:2", "9:16"};private Camera cam;private JSONStorableFloat fov;private JSONStorableFloat customAspect;private JSONStorableFloat farClip;private JSONStorableBool isPerspective;private JSONStorableBool isOn;private JSONStorableStringChooser resolutionChooser;private JSONStorableStringChooser aspectChooser;private int w = 640, h = 640;private float aspect = 1;private RenderTexture rt;public Camera Cam{get{if (cam == null){var rescaleObject = containingAtom.reParentObject.Find("object/rescaleObject");cam = Utils.GetSafeComponent<Camera>(rescaleObject.gameObject);cam.depth = -10;}return cam;}}public override void Init(){Location.InitTData();if (containingAtom.type != "Empty"){SuperController.LogError("Please apply plug-in to empty atom!");return;}UIInit();}private void UIInit(){aspectChooser = Utils.CreateStringChooser(this, Location.GetStr(Location.CameraAspect), aspectStrs, false, true);aspectChooser.setCallbackFunction = (val) =>{Utils.ActiveSliderUI(customAspect.slider, false);switch (val){case "Custom":                        Utils.ActiveSliderUI(customAspect.slider, true);aspect = customAspect.val;break;case "16:9": aspect = 1.777f;break;case "2:1": aspect = 2f;break;case "4:3": aspect = 1.333f;break;case "1:1": aspect = 1f;break;case "3:4": aspect = 0.75f;break;case "9:16": aspect = 0.5625f;break;case "1:2": aspect = 0.5f;break;default:                        break;}h = (int)(w / aspect);CreateRT();};customAspect = Utils.CreateSliderFloat(this, Location.GetStr(Location.CustomAspect), 1f, 0.1f, 5f, false, true);customAspect.setCallbackFunction = (val) =>{if (aspectChooser.val == "Custom"){aspect = customAspect.val;resolutionChooser.setCallbackFunction(resolutionChooser.val);}};resolutionChooser = Utils.CreateStringChooser(this, Location.GetStr(Location.Resolution), resolutionStrs, false, true);resolutionChooser.setCallbackFunction = (val) =>{switch (val){case "Low": w = 640;h = (int)(w / aspect);break;case "Medium": w = 1280;h = (int)(w / aspect);break;case "Large": w = 1920;h = (int)(w / aspect);break;default:                        break;}CreateRT();};SetCamera();isOn = Utils.CreateToggle(this, Location.GetStr(Location.IsCameraOn), false, false, true);isOn.setCallbackFunction = (val) =>{Cam.enabled = val;};fov = Utils.CreateSliderFloat(this, Location.GetStr(Location.FOV), 60f, 1, 180, false, true);fov.setCallbackFunction = (val) =>{Cam.fieldOfView = val;};aspectChooser.setCallbackFunction(aspectChooser.val);resolutionChooser.setCallbackFunction(resolutionChooser.val);isOn.setCallbackFunction(isOn.val);fov.setCallbackFunction(fov.val);}private void SetCamera(){CreateRT();Cam.backgroundColor = Color.black;Cam.cullingMask = ~(1 << LayerMask.NameToLayer("UI") | 1 << LayerMask.NameToLayer("Player"));}private void CreateRT(){if (rt != null) RenderTexture.ReleaseTemporary(rt);rt = RenderTexture.GetTemporary(w, h);rt.wrapMode = TextureWrapMode.Repeat;Cam.targetTexture = rt;}private void OnDestroy(){RenderTexture.ReleaseTemporary(rt);}}}